//
//  SpeechRecognizer.m
//  
//
//  Created by Johannes Wolf on 14.05.10.
//  Copyright 2010 beanage. All rights reserved.
//

#import <AppKit/AppKit.h>
#include <pub.mod/macos.mod/macos.h>

@class SpeechRecognizer;
static SpeechRecognizer *recognizer;

@interface SpeechRecognizer : NSObject {
	
	NSSpeechRecognizer	*rec;
	
}

@end

	//-

@implementation SpeechRecognizer

- (id) init
{
	self = [super init];
	if (self != nil) {
		rec = [[NSSpeechRecognizer alloc] init];
		[rec setDelegate:self];
	}
	return self;
}

	//-

- (void)speechRecognizer:(NSSpeechRecognizer *)sender didRecognizeCommand:(id)command
{
	bbSystemEmitEvent( 9329 ,bbStringFromNSString( command ) , 1, 0, 0, 0, &bbNullObject );
}

	//-

- (NSSpeechRecognizer *)get
{
	return rec;
}

@end

	//-

void RSStartController()
{
	recognizer = [[SpeechRecognizer alloc] init];
}

void RSStopController()
{
	[recognizer release];
}

	//-

void RSSetCommands( BBString *str )
{
	NSString	*string = NSStringFromBBString( str );
	NSArray		*commands = [string componentsSeparatedByString:@","];
	
	[[recognizer get] setCommands:commands];
}

void RSSetOnlyInForeground( char on )
{
	if (!on) {
		[[recognizer get] setListensInForegroundOnly:NO];
	} else {
		[[recognizer get] setListensInForegroundOnly:YES];
	}
}

void RSSetBlocksOther( char on )
{
	if (!on) {
		[[recognizer get] setBlocksOtherRecognizers:NO];
	} else {
		[[recognizer get] setBlocksOtherRecognizers:YES];
	}
}

void RSStartListening()
{
	[[recognizer get] startListening];
}

void RSStopListening()
{
	[[recognizer get] stopListening];
}
